#!/bin/bash
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Written by Vidar Jon Bauge, vidarjon@tiscali.dk
#
# Version 0.01 01.24.2006
#
#

choice=$1
user=$(whoami)

if [ "$user" = "root" ];then
	installpath="/usr/local/bin"
	iconInstallPath="/usr/share/icons"
else
	installpath="$HOME/bin"
	iconInstallPath="$HOME/bin"
fi


clear
echo "Install the mounter programs"
echo "----------------------------"
echo
echo
read -p "Enter destination ($installpath) >: " enterPath

if [ ! -z "$enterPath" ]; then
	installpath=$enterPath
fi
	
if [ ! -e $installpath ]; then
	read -p "Create directory $installpath ? (yes/no) >: " yesNo
	if [ "$yesNo" = "yes" ]; then
		mkdir $installpath
		echo "$installpath created"
	fi
else
	echo "$installpath found."
fi

#Copy the program files
################################################################################

cp ./bin/mounter $installpath
chmod 755 $installpath/mounter
echo "Copied mounter to $installpath"

#Copy the icon files
################################################################################

echo
read -p "Enter icon destination ($iconInstallPath) >: " enterPath

if [ ! -z "$enterPath" ]; then
	iconInstallPath=$enterPath
fi
	
if [ ! -e $iconInstallPath ]; then
	read -p "Create directory $iconInstallPath ? (yes/no) >: " yesNo
	if [ "$yesNo" = "yes" ]; then
		mkdir $iconInstallPath
		echo "$iconInstallPath created"
	fi
else
	echo "$iconInstallPath found."
fi

cp ./icons/floppy_icon.png $iconInstallPath
chmod 755 $iconInstallPath/floppy_icon.png
echo "Copied floppy_icon.png to $iconInstallPath"
cp ./icons/cdrom_icon.png $iconInstallPath
chmod 755 $iconInstallPath/cdrom_icon.png
echo "Copied cdrom_icon.png to $iconInstallPath"
cp ./icons/usb_icon.png $iconInstallPath
chmod 755 $iconInstallPath/usb_icon.png
echo "Copied usb_icon.png to $iconInstallPath"

echo
echo "Now run the menu_generator script to create menu entries"
echo "--------------------------------------------------------"
echo

exit
