#!/bin/bash
#
#!/bin/bash
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Written by Vidar Jon Bauge, vidarjon@tiscali.dk
#
# Version 0.01 01.24.2006


numberOfDevices=0
floppycounter=1
cdromcounder=1
installPath="$HOME/Documents/mountscripts/installer/output"
iconPath="/usr/share/icons"u
outputFilename=""
DIALOG="Xdialog"

#First make sure Xdialog is available
################################################################################

which Xdialog &> /tmp/devtemp
if cat /tmp/devtemp | grep "no Xdialog in" > /dev/null ; then
	echo "ERROR: Xdialog not installed or not in path. Try http://xdialog.dyns.net/"
	rm -f /tmp/devtemp
	exit
fi
rm -f /tmp/devtemp

################################################################################

IFS=" "
exec < /etc/fstab

while read device mountpoint field3 field4 field5 field6; \
	do
		if [ ! -z "$device" ]; then 
			device1="$(basename $device)"
			mountpoint1="$(basename $mountpoint)"
			dvp="`expr substr $device1 1 2`"
			mvp="`expr substr $mountpoint1 1 5`"
		  
			if [ "$dvp" = "fd" ]; then
				typeString["$numberOfDevices"]="Floppy$floppycounter"
				iconString["$numberOfDevices"]="floppy_icon.png"
				devString["$numberOfDevices"]=$device
				mntString["$numberOfDevices"]=$mountpoint
				((floppycounter = floppycounter + 1))
				((numberOfDevices = numberOfDevices + 1))
				
			elif [ "$dvp" = "hd" -a "$mvp" = "cdrom" ]; then
				typeString["$numberOfDevices"]="Cdrom$cdromcounder"
				iconString["$numberOfDevices"]="cdrom_icon.png"
				devString["$numberOfDevices"]=$device
				mntString["$numberOfDevices"]=$mountpoint
				((cdromcounder = cdromcounder + 1))
				((numberOfDevices = numberOfDevices + 1))
				
			fi
		fi
	done \


#Subroutine that shows an error message, if there is one
#####################################################################################

tempfile=`tempfile 2>/dev/null` || tempfile=/tmp/tmpMountDevice$$
trap "rm -f $tempfile" 0 1 2 5 15

showResult()
{
	if [ ! -z "$resultString" ]; then
		len=${#resultString}
		len=len+4
		$DIALOG --title "$result $actionString" \
        	--msgbox "$resultString" 0 len
	fi
	resultString=""
}

#setInstallPath
################################################################################

setInstallPath()
{

installPath=$($DIALOG --stdout --title "Output directory" \
--backtitle "Select the output folder" \
--dselect "$HOME" 0 0)

if [ -z $installPath ];then
 exit
fi
}

# editResult
################################################################################

editResult()
{
echo $($DIALOG --stdout --title "$(basename $outputFilename)" \
--no-cancel --backtitle "Edit the output file" \
--editbox "$outputFilename" 0 0) > $outputFilename 

resultString="Now copy the content of\n\n$outputFilename\n\n and \
paste it into you $desk menu file"
showResult
}

editResultIdesk()
{
echo $($DIALOG --stdout --title "$(basename $outputFilename)" \
--no-cancel --backtitle "Edit the output file" \
--editbox "$outputFilename" 0 0) > $outputFilename 

}

# IceWM
################################################################################

icewm()
{

setInstallPath

outputFilename="$installPath"icewmmenu

if [ -e "$outputFilename" ]; then
	mv "$outputFilename" "$outputFilename~"
	echo "Backup of $outputFilename created"
fi

iconPath=$($DIALOG --stdout --title "IceWM" \
--backtitle "Select the folder that contains the icons" \
--dselect "$HOME" 0 0)

if [ -z $iconPath ];then
 exit
fi

counter=0
echo "menu Disks" { > $outputFilename

while [ "$counter" -lt "$numberOfDevices" ]

do
	echo "	prog ${typeString["$counter"]} $iconPath${iconString["$counter"]} "mounter" ${devString["$counter"]}" >> $outputFilename
	
	((counter = counter + 1))
done

echo "	prog UsbMounter "$iconPath"usb-icon.png mounter usb"  >> $outputFilename
echo } >> $outputFilename

desk="IceWM"
editResult

}
#End IceWM
################################################################################

#BlackBox/Fluxbox
################################################################################

blackbox()
{
setInstallPath

outputFilename="$installPath"bbmenu

if [ -e "$outputFilename" ]; then
	mv "$outputFilename" "$outputFilename~"
	echo "Backup of $outputFilename created"
fi

counter=0
echo "[submenu] (Disks)" > $outputFilename

while [ "$counter" -lt "$numberOfDevices" ]

do
	echo "	[exec] (${typeString["$counter"]}) {mounter ${devString["$counter"]}}" >> $outputFilename
	
	((counter = counter + 1))
done

echo "	[exec] (UsbMounter) {mounter usb}"  >> $outputFilename
echo "[end]" >> $outputFilename

desk="BlackBox/Fluxbox"
editResult

}
#End BlackBox/Fluxbox
################################################################################

#xfce
################################################################################

xfce()
{
	
setInstallPath

outputFilename="$installPath"xfcemenu

if [ -e "$outputFilename" ]; then
	mv "$outputFilename" "$outputFilename~"
	echo "Backup of $outputFilename created"
fi

counter=0
echo "<menu name=\"Disks\">"  > $outputFilename

while [ "$counter" -lt "$numberOfDevices" ]

do
	echo "	<app name=\"${typeString["$counter"]}\"  "cmd=\"mounter" ${devString["$counter"]}"\"\/\>"" >> $outputFilename
	
	((counter = counter + 1))
done

echo "	<app name=\"UsbMounter\" cmd=\"mounter usb\"/>"  >> $outputFilename
echo "</menu>" >> $outputFilename

echo $($DIALOG --stdout --title "$(basename $outputFilename)" --backtitle "Edit the output file" \
--editbox "$outputFilename" 0 0) > $outputFilename 

desk="Xfce"
editResult

}

#End xfce
################################################################################

#windowmaker
################################################################################

windowmaker()
{

setInstallPath

outputFilename="$installPath"wmakermenu

if [ -e "$outputFilename" ]; then
	mv "$outputFilename" "$outputFilename~"
	echo "Backup of $outputFilename created"
fi

counter=0
echo "(\"Disks\"," > $outputFilename

while [ "$counter" -lt "$numberOfDevices" ]

do
	echo "	(\"${typeString["$counter"]}\", EXEC, \"mounter ${devString["$counter"]}\")," >> $outputFilename
	
	((counter = counter + 1))
done

echo "	(\"prog UsbMounter\", EXEC, \" mounter usb\")"  >> $outputFilename
echo ")," >> $outputFilename

desk="WindowMaker"
editResult

}

#End windowmaker
################################################################################

#pekwm
################################################################################
pekwm()
{

setInstallPath

outputFilename="$installPath"pekmenu

if [ -e "$outputFilename" ]; then
	mv "$outputFilename" "$outputFilename~"
	echo "Backup of $outputFilename created"
fi

counter=0
echo "Submenu = \"Disks\"" { > $outputFilename

while [ "$counter" -lt "$numberOfDevices" ]

do
	echo "	Entry = \"${typeString["$counter"]}\" "{  Actions = \"Exec mounter" ${devString["$counter"]} &\" }" >> $outputFilename
	
	((counter = counter + 1))
done

echo "	Entry = \"UsbMounter\"  {  Actions = \"Exec mounter usb &\" }"  >> $outputFilename
echo } >> $outputFilename

desk="PekWM"
editResult

}

#End pekwm
################################################################################

#Deskmenu
################################################################################

deskmenu()
{
setInstallPath

outputFilename="$installPath"deskmenu

if [ -e "$outputFilename" ]; then
	mv "$outputFilename" "$outputFilename~"
	echo "Backup of $outputFilename created"
fi

counter=0
echo "submenu=Disks" > $outputFilename

while [ "$counter" -lt "$numberOfDevices" ]

do
	echo "menuitem=${typeString["$counter"]}":mounter" ${devString["$counter"]}" >> $outputFilename
	
	((counter = counter + 1))
done

echo "menuitem=UsbMounter:mounter usb"  >> $outputFilename
echo "endmenu=" >> $outputFilename

desk="DeskMenu"
editResult

}

#End Deskmenu
################################################################################


#Idesk
################################################################################
idesk()
{

installPath=$($DIALOG --stdout --title "Idesk" \
--backtitle "Select the output folder" \
--dselect "$HOME/.idesktop" 0 0)

if [ -z $installPath ];then
 exit
fi

iconPath=$($DIALOG --stdout --title "IceWM" \
--backtitle "Select the folder that contains the icons" \
--dselect "$HOME" 0 0)

if [ -z $iconPath ];then
 exit
fi

counter=0
X=400
Y=100

cd $installPath
while [ "$counter" -lt "$numberOfDevices" ]

do
	outputFilename="$installPath/${typeString["$counter"]}.lnk"

	if [ -e "$outputFilename" ]; then
		mv "$outputFilename" "$outputFilename~"
		echo "Backup of $outputFilename created"
	fi

	echo "table Icon" >> $outputFilename
	echo "	Caption ${typeString["$counter"]}" >> $outputFilename
	echo "	Icon: $iconPath${iconString["$counter"]}" >> $outputFilename
	echo "	X: $X" >> $outputFilename
	echo "	Y: $Y" >> $outputFilename
	echo "	Command[0]: "mounter" ${devString["$counter"]}" >> $outputFilename
	echo "	Command[1]: idesktool ${typeString["$counter"]}.lnk" >> $outputFilename
	echo "end" >> $outputFilename
	echo "	prog ${typeString["$counter"]} ${iconString["$counter"]} "mounter" ${devString["$counter"]}"
	
	((counter = counter + 1))
	((Y = Y + 64))
	
	editResultIdesk
done

	outputFilename="$installPath/UsbMounter.lnk"
	
	if [ -e "$outputFilename" ]; then
		mv "$outputFilename" "$outputFilename~"
		echo "Backup of $outputFilename created"
	fi
	
	echo "table Icon" >> $outputFilename
	echo "	Caption UsbMounter" >> $outputFilename
	echo "	Icon: $iconPath$iconPath/usb_icon.png" >> $outputFilename
	echo "	X: $X" >> $outputFilename
	echo "	Y: $Y" >> $outputFilename
	echo "	Command[0]: mounter usb" >> $outputFilename
	echo "	Command[1]: idesktool UsbMounter.lnk" >> $outputFilename
	echo "end" >> $outputFilename
	
	editResultIdesk
	
	resultString="Restart Idesk and place the icons"
	showResult
}
#End Idesk
################################################################################

$DIALOG --clear --title "Create menu entries" \
        --menu "Choose desktop" 16 40 4 \
        "IceWM"  "Menuentries for IceWM" \
		"BlackBox"  "Menuentries for BlackBox" \
		"FluxBox"  "Menuentries for FluxBox" \
		"Xfce"  "Menuentries for Xfce" \
		"WindowMaker"  "Menuentries for WindowMaker" \
		"PekWM"  "Menuentries for PekWM" \
		"Deskmenu"  "Menuentries for Deskmenu" \
        "Idesk" "Icons for Idesk"  2> $tempfile
        		
retval=$?

case $retval in
  0)
  	choice=`cat $tempfile`
    case $choice in
		"IceWM") icewm
		;;
		"BlackBox") blackbox
		;;
		"FluxBox") blackbox
		;;
		"Xfce") xfce
		;;
		"WindowMaker") windowmaker
		;;
		"PekWM") pekwm
		;;
		"Deskmenu") deskmenu
		;;
		"Idesk") idesk
		;;
	esac
	;;
	1)
    echo "$cancelled"
	exit
	;;
	255)
    echo "$esc"
	exit
	;;
esac
